<template>
	<main>
		<div class="cards">
			<h1>Reservierungen</h1>
			<div class="card-body">
				<form v-on:submit.prevent >
					<div class="cols c-1-1 mobile-flex">
						<div>
							<div class="cell">Vorname</div>
							<div class="cell">
								<input ref="firstName" v-model="form.firstName" class="input input--full-w" type="text" name="firstName" required />
							</div>
						</div>
						<div>
							<div class="cell">Nachname</div>
							<div class="cell">
								<input ref="lastName" v-model="form.lastName" class="input input--full-w" type="text" name="lastName" required />
							</div>
						</div>

						<div>
							<div class="cell">E-Mail Adresse</div>
							<div class="cell">
								<input ref="email" v-model="form.email" class="input input--full-w" type="email" name="email" required />
							</div>
						</div>
						<div>
							<div class="cell">Telephon Nr.</div>
							<div class="cell">
								<input ref="phoneNr" v-model="form.phoneNr" class="input input--full-w" type="text" name="phoneNr" placeholder="+43 ..." required />
							</div>
						</div>

						<div>
							<div class="cell">Gew&uuml;nschtes Datum von</div>
							<div class="cell">
								<input @change="forceDateCorrection" ref="eventDateStart" v-model="form.eventDateStart" class="input input--full-w" type="date" name="eventDateStart" required />
							</div>
						</div>
						<div>
							<div class="cell">bis</div>
							<div class="cell">
								<input @change="forceDateCorrection" ref="eventDateEnd" v-model="form.eventDateEnd" class="input input--full-w" type="date" name="eventDateEnd" required />
							</div>
						</div>
					</div>

					<div class="cell">Nachricht</div>
					<div class="cell">
						<textarea ref="message" v-model="form.message" class="input input--full-w" rows="7 required"></textarea>
					</div>
					<div class="cell">
						<button type="submit" class="button button--mobile-stretch" @click="submitRequest">Absenden</button>
					</div>
				</form>
			</div>
		</div>
		<system-message v-if="sysMsg" :msg.sync="sysMsg" />
	</main>
</template>

<script>
import systemMessage from "@/components/SystemMessage";
export default {
	name: "Bookings",
	title: "Bookings",
	components: { systemMessage },
	props: {
		setDate: String
	},
	data: () => ({
		form: {
			firstName: "",
			lastName: "",
			email: "",
			phoneNr: "",
			eventDateStart: "",
			eventDateEnd: "",
			message: ""
		},
		sysMsg: undefined
	}),
	methods: {
		async submitRequest() {
			this.sysMsg = "";
			let verified = this.globalValidateForm();

			if (!verified) {
				this.sysMsg = "Fehlende Eingaben!";
				return;
			}

			let submit = {...this.form};
			submit.name = this.form.firstName + " " + this.form.lastName;

			try {
				const response = await this.$http.post("/api/request", submit);
				switch (response.status) {
					case 201:
						this.globalEmptyForm();
						this.sysMsg = "Anfrage erfolgreich versandt!";
						break;
					case 202:
						this.sysMsg = "Ausgewaehltes Datum nicht verfuegbar!";
						this.$refs.eventDateStart.classList.add("input--alert");
						this.$refs.eventDateEnd.classList.add("input--alert");
						break;
				}
			} catch (e) {
				switch (e.response.data) {
					case "invalid_mail_pattern":
						this.sysMsg = "Ungültige E-Mail Adresse!";
						this.$refs.email.classList.add("input--alert");
						this.$refs.email.focus();
						break;
					case "invalid_phone_pattern":
						this.sysMsg = "Ungültige Telephonnummer!";
						this.$refs.phoneNr.classList.add("input--alert");
						this.$refs.phoneNr.focus();
						break;
					case "start_after_end":
						this.sysMsg = "Ungültige Zeitspanne!";
						this.$refs.eventDateStart.classList.add("input--alert");
						this.$refs.eventDateEnd.classList.add("input--alert");
						this.$refs.eventDateStart.focus();
						break;
					default:
						console.error(e.response);
				}
			}
		},

		forceDateCorrection() {
			let dateStart = this.$refs.eventDateStart;
			let dateEnd = this.$refs.eventDateEnd;
			if (!!dateStart || !!dateEnd) {
				if (dateStart.value > dateEnd.value) {
					dateEnd.value = dateStart.value;
					this.form.eventDateEnd = dateStart.value;
				}
			}
		}
	},
	computed: {
	},
	mounted() {
		if (this.setDate) {
			let dateSplit = this.setDate.split("-");
			this.form.eventDateStart = this.form.eventDateEnd =
				dateSplit[0] + "-"
				+ (dateSplit[1].length < 2 ? "0" + dateSplit[1] : dateSplit[1])
				+ "-"
				+ (dateSplit[2].length < 2 ? "0" + dateSplit[2] : dateSplit[2])
		}
	}
}
</script>

<style scoped>

</style>